src/backend/protected/modules/shop/models/Products.php
<?php
Yii::import('common.models.db.ShopProductsModel');
class Products extends ShopProductsModel
{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return Shop::module()->productsTable;
	}
	public function beforeSave()
	{
		$this->updated_datetime = new CDbExpression('NOW()');
		if($this->isNewRecord){
			$this->created_datetime = new CDbExpression('NOW()');
		}
		return parent::beforeSave();
	}
	public function beforeValidate() {
		if(Yii::app()->language == 'de')
			$this->price = str_replace(',', '.', $this->price);
		
		return parent::beforeValidate();
	}
	public function beforeDeleteFix($product_id)
	{
		$countImages = self::model()->with('imagesCount')->findByPk($product_id);
		if(isset($countImages->imagesCount) && $countImages->imagesCount>0){
			$del = Image::model()->deleteAll('product_id='.$product_id);
		}
	}

	/*public function rules()
	{
		return array(
			array('title,alias', 'required'),
			array('product_id, category_id, published, featured,ordering', 'numerical', 'integerOnly'=>true),
			array('price, language', 'length', 'max'=>45),
			array('title,alias,sku,old_price', 'length', 'max'=>255),
			array('description, specifications, description_full, description_more, created_datetime, updated_datetime', 'safe'),
			array('product_id, sku, title, description, description_full, description_more, image, image2, image3, image4, old_price, price, category_id', 'safe', 'on'=>'search'),
		);
	}*/

	/*public function relations()
	{
		return array(
			'variations' => array(self::HAS_MANY, 'ProductVariation', 'product_id', 'order' => 'position'),
			'orders' => array(self::MANY_MANY, 'Order', 'ShopProductOrder(order_id, product_id)'),
			'category' => array(self::BELONGS_TO, 'Category', 'category_id'),
			'tax' => array(self::BELONGS_TO, 'Tax', 'tax_id'),
			'images' => array(self::HAS_MANY, 'Image', 'product_id'),
			'imagesCount'=> array(self::STAT, 'Image', 'product_id'),
			'shopping_carts' => array(self::HAS_MANY, 'ShoppingCart', 'product_id'),
		);
	}*/

	public function getSpecification($spec) {
		$specs = json_decode($this->specifications, true);

		if(isset($specs[$spec]))
			return $specs[$spec];

		return false;
	}

	public function getImage($image = 0, $thumb = false) {
		if(isset($this->images[$image]))
			return Yii::app()->controller->renderPartial('/image/view', array(
				'model' => $this->images[$image],
				'thumb' => $thumb), true); 
	}

	public function getSpecifications() {
		$specs = json_decode($this->specifications, true);
		return $specs === null ? array() : $specs;
	}

	public function setSpecification($spec, $value) {
		$specs = json_decode($this->specifications, true);

		$specs[$spec] = $value;

		return $this->specifications = json_encode($specs);
	}

	public function setSpecifications($specs) {
		foreach($specs as $k => $v)
			$this->setSpecification($k, $v);
	}

	public function setVariations($variations) {
		$db = Yii::app()->db;
		$db->createCommand()->delete('shop_product_variation',
				'product_id = :product_id', array(
					':product_id' => $this->product_id));

		foreach($variations as $key => $value) {
			if($value['specification_id'] 
					&& isset($value['title']) 
					&& $value['title'] != '') {

				if(isset($value['sign']) && $value['sign'] == '-')
					$value['price_adjustion'] -= 2 * $value['price_adjustion'];


				$db->createCommand()->insert('shop_product_variation', array(
							'product_id' => $this->product_id,
							'specification_id' => $value['specification_id'],
							'position' => @$value['position'] ?'': 0,
							'title' => $value['title'],
							'price_adjustion' => @$value['price_adjustion'] ?'': 0,
							));	
			}
		}
	}

		public function getVariations() {
		$variations = array();
		foreach($this->variations as $variation) {
			$variations[$variation->specification_id][] = $variation;
		}		

		return $variations;
	}


	public function attributeLabels()
	{
		return array(
			'product_id' => Yii::t('ShopModule.shop', 'Product'),
			'title' => Yii::t('ShopModule.shop', 'Product Name'),
			'description' => Yii::t('ShopModule.shop', 'Description'),
			'description_full' => Yii::t('ShopModule.shop', 'Description full'),
			'description_more' => Yii::t('ShopModule.shop', 'Description More'),
			'price' => Yii::t('ShopModule.shop', 'Price'),
			'old_price' => Yii::t('ShopModule.shop', 'Old Price'),
			'category_id' => Yii::t('ShopModule.shop', 'Categories'),
			'featured' => Yii::t('ShopModule.shop', 'Featured'),
			'published' => Yii::t('ShopModule.shop', 'Published'),
			'sku' => Yii::t('ShopModule.shop', 'SKU'),
			'manufactor_id' => Yii::t('ShopModule.shop', 'Manufactor'),
			'ordering' => Yii::t('ShopModule.shop', 'Ordering'),
			'saleoff_percent' => Yii::t('ShopModule.shop', 'Saleoff Percent'),
			'is_hot' => Yii::t('ShopModule.shop', 'Is Hot'),
			'is_new' => Yii::t('ShopModule.shop', 'Is New'),
			'is_saleoff' => Yii::t('ShopModule.shop', 'Is Saleoff'),
			'is_premium' => Yii::t('ShopModule.shop', 'Is Premium'),
		);
	}

	public function getTaxRate($variations = null, $amount = 1) { 
		if($this->tax) {
			$taxrate = $this->tax->percent;	
			$price = (float) $this->price;
			if($variations)
				foreach($variations as $key => $variation) {
					$price += @ProductVariation::model()->findByPk($variation[0])->price_adjustion;
				}


			(float) $price *= $amount;

			(float) $tax = $price * ($taxrate / 100);

			return $tax;
		}
	}
	public function getPrice($variations = null, $amount = 1) {
		$price = (float) $this->price;
		if($variations)
			foreach($variations as $key => $variation) {
				$price += @ProductVariation::model()->findByPk($variation[0])->price_adjustion;
			}


		(float) $price *= $amount;

		return $price;
	}

	public function search()
	{

		$criteria=new CDbCriteria;

		$criteria->compare('product_id',$this->product_id);
		$criteria->compare('title',$this->title,true);
		$criteria->compare('description',$this->description,true);
		$criteria->compare('old_price',$this->old_price,true);
		$criteria->compare('price',$this->price,true);
		$criteria->compare('category_id',$this->category_id);
		$criteria->compare('published',$this->published);
		$criteria->compare('featured',$this->featured);
		return new CActiveDataProvider('Products', array(
			'criteria'=>$criteria,
			'sort'=>array(
            	'defaultOrder'=>'product_id DESC',
	        ),
	        'pagination'=>array(
	            'pageSize'=>20
	        ),
		));
	}
}

src/backend/protected/modules/shop/controllers/ProductsController.php
<?php
/**
 * @name ProductsController
 * @version 2.0
 * @author Nguyen Van Phuong, <phuong.nguyen.itvn@gmail.com>
 * @copyright 2011 PN68 CMS
 */
class ProductsController extends BackendApplicationController
{
	public $_model;
	public $layout = 'application.modules.shop.views.layouts.products';
	function init(){
		parent::init();
	  if(isset($_POST['SESSION_ID'])){
	    $session=Yii::app()->getSession();
	    $session->close();
	    $session->sessionID = $_POST['SESSION_ID'];
	    $session->open();
	  }
	}
	public function beforeAction($action) {
		return parent::beforeAction($action);
	}

	public function actionView()
	{
		$id = Yii::app()->request->getParam('id');
		$this->render('view',array(
			'model'=>$this->loadModel($id, 'Products'),
		));
	}

	public function actionCreate()
	{
		$model=new Products;

		 $this->performAjaxValidation($model, 'products-form');

		if(isset($_POST['Products']))
		{
			$model->attributes=$_POST['Products'];
			if(isset($_POST['Specifications']))
				$model->setSpecifications($_POST['Specifications']);

			//$model->category_id=1;
			if($model->save()){
				if(isset($_POST['image_thumb']) && $_POST['image_thumb']!=''){
					$filePath = Yii::app()->params['tmp_path'].DS.$_POST['image_thumb'];
					if(file_exists($filePath)){
						AvatarHelper::processThumb($model->product_id, $filePath, 'products');
					}
				}
				//process images
				if(isset($_POST['images']) && $_POST['images']!=''){
					foreach ($_POST['images'] as $key => $value) {
						$imageName = $value['name'];
						$imageId = $value['id'];
						if(!empty($imageName)){
							if($imageId>0){
								$imageModel = BackendShopProductImages::model()->findByPk($imageId);
							}else{
								$imageModel = new BackendShopProductImages();
							}
							
							$imageModel->product_id = $model->product_id;
							$imageModel->name = $imageName;
							if($imageModel->save(false)){
								$filePath = Yii::app()->params['tmp_path'].DS.$imageName;
								if(file_exists($filePath)){
									AvatarHelper::processThumb($imageModel->id, $filePath, 'productimages');
								}
							}
						}
					}
				}

				//BackendShopProductCategoryModel::model()->updateProductAndCategory($model->product_id, $_POST['Products']['category_id']);
				Yii::app()->user->setFlash('success', Shop::t('Created success!'));
				if($_POST['apply']==1){
						$this->redirect(array('update', 'id' => $model->product_id));
					}else{
						$this->redirect(array('admin', 'id' => $model->product_id));
					}
			}else{
				Yii::app()->user->setFlash('success', Shop::t('Created fail!'));
			}
				
		}

		$this->render('create',array(
			'model'=>$model,
		));
	}

	public function actionUpdate($id, $return = null)
	{
		$model=$this->loadModel($id, 'Products');

		$this->performAjaxValidation($model, 'products-form');

		if(isset($_POST['Products']))
		{
			$model->attributes=$_POST['Products'];
			if(isset($_POST['Specifications']))
				$model->setSpecifications($_POST['Specifications']);
			if(isset($_POST['Variations']))
				$model->setVariations($_POST['Variations']);
			//$model->category_id=1;
			if($model->save())
			{
				if(isset($_POST['image_thumb']) && $_POST['image_thumb']!=''){
					$filePath = Yii::app()->params['tmp_path'].DS.$_POST['image_thumb'];
					if(file_exists($filePath)){
						AvatarHelper::processThumb($model->product_id, $filePath, 'products');
					}
				}
				//process images
				if(isset($_POST['images']) && $_POST['images']!=''){
					foreach ($_POST['images'] as $key => $value) {
						$imageName = $value['name'];
						$imageId = $value['id'];
						if(!empty($imageName)){
							if($imageId>0){
								$imageModel = BackendShopProductImages::model()->findByPk($imageId);
							}else{
								$imageModel = new BackendShopProductImages();
							}
							
							$imageModel->product_id = $model->product_id;
							$imageModel->name = $imageName;
							if($imageModel->save(false)){
								$filePath = Yii::app()->params['tmp_path'].DS.$imageName;
								if(file_exists($filePath)){
									AvatarHelper::processThumb($imageModel->id, $filePath, 'productimages');
								}
							}
						}
					}
				}
				//BackendShopProductCategoryModel::model()->updateProductAndCategory($id, $_POST['Products']['category_id']);
				Yii::app()->user->setFlash('success', Shop::t('Updated success!'));
				if($_POST['apply']==1){
						$this->redirect(array('update', 'id' => $model->product_id));
					}else{
						$this->redirect(array('admin'));
					}
			}else{
				Yii::app()->user->setFlash('success', Shop::t('Updated fail!'));
			}
		}

		$this->render('update',array(
			'model'=>$model,
		));
	}

	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'index' page.
	 */
	public function actionDelete($id)
	{
		if(Yii::app()->request->isPostRequest)
		{
			// we only allow deletion via POST request
			//Products::model()->beforeDeleteFix($id);
			$model = Products::model()->findByPk($id);
			$model->published=2;
			$model->save(false);

			// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
			if(!isset($_POST['ajax']))
				$this->redirect(array('index'));
			Yii::app()->end();
		}
		else
			throw new CHttpException(400,'Invalid request. Please do not repeat this request again.');
	}

	/**
	 * Lists all models.
	 */
	public function actionIndex()
	{
		$dataProvider = new CActiveDataProvider('Products');

		$this->render('index',array(
			'dataProvider'=>$dataProvider,
		));
	}

	/**
	 * Manages all models.
	 */
	public function actionAdmin()
	{
		$model=new Products('search');
		$model->unsetAttributes();
		if(isset($_GET['Products']))
			$model->attributes=$_GET['Products'];
		$this->render('admin',array(
			'model'=>$model,
		));
	}

	public function actionToggle($id,$attribute)
	{
        // we only allow deletion via POST request
        $model = $this->loadModel($id,'Products');
        ($model->$attribute==1)?$model->$attribute=0:$model->$attribute=1;
        $model->save();
 
        // if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
        $this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
        
    }
    public function actionDelimage()
    {
    	$productId = Yii::app()->request->getParam('productId');
    	$field = Yii::app()->request->getParam('field');
    	
    	$model=$this->loadModel($productId, 'Products');
    	$media_path = Yii::app()->params['shop_path'];
    	$directory = array_keys(Yii::app()->params['shop']['images']);
    	@unlink($media_path.'/full/'.$model->$field);
    	foreach ($directory as $dir){
			if(is_file($media_path.'/'.$dir.'/'.$model->$field)){
				@unlink($media_path.'/'.$dir.'/'.$model->$field);
			}
		}
		$model->$field = "";
		$model->save();
    	$data['error'] = false;
    	echo CJSON::encode($data);
    }
    /**
     * upload image primary for product
     */
	public function actionUpload()
	{
		if(isset($_POST['ProductImage'])){
			$id = $_POST['model_id'];
			if(isset($_FILES['ProductImage']['name']['image']) && !empty($_FILES['ProductImage']['name']['image']))
			{
				$field = 'image';
			}else if(isset($_FILES['ProductImage']['name']['image2']) && !empty($_FILES['ProductImage']['name']['image2']))
			{
				$field = 'image2';
			}else if(isset($_FILES['ProductImage']['name']['image3']) && !empty($_FILES['ProductImage']['name']['image3']))
			{
				$field = 'image3';
			}else if(isset($_FILES['ProductImage']['name']['image4']) && !empty($_FILES['ProductImage']['name']['image4']))
			{
				$field = 'image4';
			}
			$directory = array_keys(Yii::app()->params['shop']['images']);
			$media_path = Yii::app()->params['shop_path'];
			//get file type and check avaiable
			
			$file = $_FILES['ProductImage']['name'][$field];
			$file = utf8_decode($file);
			$file = preg_replace("/[^a-zA-Z0-9_.\-\[\]]/i", "", strtr($file, "()áàâãäéèêëíìîïóòôõöúùûüçÁÀÂÃÄÉÈÊËÍÌÎÏÓÒÔÕÖÚÙÛÜÇ% ", "[]aaaaaeeeeiiiiooooouuuucAAAAAEEEEIIIIOOOOOUUUUC__"));
			$file = strtolower($file);
			$filepath = pathinfo($file);
			$file_type_avaiable = $_POST['fileext'];
			$ext_file = $filepath['extension'];
			//check file type is avaiable?
				$fileTypes = str_replace('*.','',$file_type_avaiable);
				$fileTypes = str_replace(';','|',$fileTypes);
				$typesArray = @split('\|',$fileTypes);
			
			if (!in_array($ext_file,$typesArray)) { 
				echo 'error_file_type';
				Yii::app()->end();
			}else{
				
				$myPicture=CUploadedFile::getInstanceByName("ProductImage[$field]");
				
				$image_name = Common::EncryptClientId($id).time().'_'.$field.'.'.$ext_file;
				
				$dir_full = $media_path.'/full';
				if(is_dir($dir_full)==false) mkdir($dir_full);
				
				if($myPicture->saveAs($dir_full.'/'.$image_name)){
					//update to db
					//$model = new Products($id);
					$model = $this->loadModel($id, 'Products');
					//echo 'error_file_upload';echo $model->image;die('dcm');
					if($model->$field!=''){
						foreach ($directory as $dir){
							@unlink($media_path.'/full/'.$model->$field);
							if(is_file($media_path.'/'.$dir.'/'.$model->$field)){
								@unlink($media_path.'/'.$dir.'/'.$model->$field);
							}
						}
					}
					//resize
					foreach ($directory as $dir){
						$image = Yii::app()->image->load($dir_full.'/'.$image_name);
						//$image->resize($_POST['size_x'], $_POST['size_y']);
						$width = Yii::app()->params['shop']['images'][$dir]['width'];
						$sub_dir = $media_path.'/'.$dir;
						if(is_dir($sub_dir)==false) {
							mkdir($sub_dir); chmod($sub_dir, 0777);
						}
						$image->resize($width, NULL);
						$image->save($sub_dir.'/'.$image_name);
					}
					$model->$field = $image_name;
					$model->save();
					echo Yii::app()->params['shop_url'].'/'.$directory[0].'/'.$image_name;
					
				}else{
				     echo 'error_file_upload';
				     Yii::app()->end();
				}
			}
	  	}
	  	Yii::app()->end();
	}
}

src/backend/protected/modules/shop/views/products/_search.php
<div class="wide form">

<?php $form=$this->beginWidget('CActiveForm', array(
	'action'=>Yii::app()->createUrl($this->route),
	'method'=>'get',
	'htmlOptions'=>array('class'=>'basic-form inline-form')
)); ?>

	<div class="row">
		<div class="col-md-2">
		<?php echo $form->label($model,'title'); ?>
		</div>
		<div class="col-md-10">
		<?php echo $form->textField($model,'title',array('size'=>45,'maxlength'=>45)); ?>
		</div>
	</div>

	<div class="row">
		<div class="col-md-2">
		<?php echo $form->label($model,'category_id'); ?>
		</div>
		<div class="col-md-10">
		<?php 
		$data = CHtml::listData(Category::model()->published()->findAll(array('order'=>'position ASC')), 'category_id', 'title_tree');
		echo $form->dropdownList($model,'category_id', $data, array('prompt'=>Yii::t('main','All'))); ?>
		</div>
	</div>
	
	<div class="row buttons">
		<?php echo CHtml::submitButton('Search', array('class'=>'btn btn-primary')); ?>
	</div>

<?php $this->endWidget(); ?>

</div><!-- search-form -->

src/backend/protected/modules/shop/views/products/_view.php
<?php 
?>
<div class="view">
    <h3>
		<?php echo CHtml::link(CHtml::encode($data->title), array('products/view', 'id' => $data->product_id)); ?>
    </h3>
    
    <div class="product-overview-image">	
          	<?php 
		  	if($data->images){
		   		$this->renderPartial('/image/view', array('thumb' =>true, 'model' => $data->images[0]));
			}else {
				echo CHtml::image(Shop::register('no-pic.jpg'));
			}?>
	</div>
    
     <div class="product-overview-description">
        <p> <?php echo CHtml::encode($data->description); ?> </p>
        <p><strong> <?php echo Shop::priceFormat($data->price); ?></strong> <br />
        <p><?php echo Shop::pricingInfo(); ?></p>
      
        <p><?php echo CHtml::link(Shop::t('show product'), array('products/view', 'id' => $data->product_id), array('class' =>'show-product')); ?></p>
    </div>
    
    <div class="clear"></div>
</div>
<div class="view-bottom"></div>

src/backend/protected/modules/shop/views/products/addToCart.php
<?php
echo Shop::renderFlash();
echo '<div class="product-price-info">';
echo Shop::pricingInfo();
echo '</div>';

echo CHtml::beginForm(array('shoppingCart/create'));

if($variations = $model->getVariations()) {
	$i = 0;
	foreach($variations as $variation) {
		$i++;
		$field = "Variations[{$variation[0]->specification_id}][]";
		echo '<div class="product_variation product_variation_'.$i.'">';
		echo CHtml::label($variation[0]->specification->title,
				$field, array(
					'class' => 'lbl-header'));

		if($variation[0]->specification->required)
			echo ' <span class="required">*</span>';

		echo  '<br />';
		if($variation[0]->specification->is_user_input) {
			echo CHtml::textField($field);
		}
		else {
			// If the specification is required, preselect the first field. Otherwise
			// let the customer choose which one to pick
			echo CHtml::radioButtonList($field,
					$variation[0]->specification->required ? $variation[0]->id : null,
					ProductVariation::listData($variation));
		}
		echo '</div>';
		if($i % 2 == 0)
			echo '<div style="clear: both;"></div>';
	}

}

echo '<div style="clear: both;"></div>';
echo '<br />';
echo CHtml::hiddenField('product_id', $model->product_id);
echo CHtml::label(Shop::t('Amount'), 'ShoppingCart_amount');
echo ': ';
echo CHtml::textField('amount', 1, array('size' => 3));
echo '<br />';

echo CHtml::submitButton(Shop::t('Add to shopping Cart'), array( 'class' => 'btn-add-cart'));
echo CHtml::endForm();
?>

src/backend/protected/modules/shop/views/products/admin.php
<?php 
Yii::app()->getModule('shop')->setTitle(Yii::t('ShopModule.shop','Products Manager'));
Yii::app()->clientScript->registerScript('search', "
$('.search-button').click(function(){
	$('.search-form').toggle();
	return false;
});
$('.search-form form').submit(function(){
	$.fn.yiiGridView.update('products-grid', {
		data: $(this).serialize()
	});
	return false;
});
");
?>
<div class="search-form">
<?php $this->renderPartial('_search', array(
		'model' => $model,
)); ?>
</div><!-- search-form -->
<?php 
$this->widget('application.widgets.iGridView', array(
	'id'=>'products-grid',
	'dataProvider'=>$model->search(),
	'columns'=>array(
		array(
			'header'=>CHtml::checkBox("all",false,array("id"=>"check_all","class"=>"icheck-all")),
			'value'=>'CHtml::checkBox("rad_ID[]",false,array("value"=>$data->product_id,"class"=>"icheck-blue"))',
			'type'=>'raw'
		),
		array(
			'header'=>'Image',
			'type'=>'raw',
			'value'=>'CHtml::image(AvatarHelper::getThumbUrl($data->product_id, "products","sm"),"",array("width"=>"50"))'
		),
		array(
			'name'	=>	'title',
			'type'	=>	'raw',
			'value'	=>	'CHtml::link(CHtml::encode($data->title), array("/shop/products/update","id"=>$data->product_id))'
		),
		array(
			'type'	=>	'raw',
			'name'	=>	'category_id',
			'value'	=>	'$data->category->title',
		),
		'price',
		array(
            'class'=>'JToggleColumn',
            'name'=>'published', // boolean model attribute (tinyint(1) with values 0 or 1)
            'htmlOptions'=>array('width'=>80),
		),
		array(
			'header'=>'Lượt xem',
			'value'=>'isset($data->statistic->views)?$data->statistic->views:0'
		),
		array(
			'class'=>'application.widgets.iButtonColumn',
			'htmlOptions'=>array('class'=>'actions'),
		),
	)
)
); 

?>

src/backend/protected/modules/shop/views/products/create.php
<?php Yii::app()->getModule('shop')->setTitle(Yii::t('main','Create'));?>
<?php echo $this->renderPartial('_form', array('model'=>$model)); ?>

src/backend/protected/modules/shop/views/products/index.php
<?php
Shop::renderFlash();
?>

<h2><?php echo Shop::t('All products'); ?></h2>

<?php $this->widget('zii.widgets.CListView', array(
	'dataProvider'=>$dataProvider,
	'itemView'=>'_view',
)); ?>

src/backend/protected/modules/shop/views/products/update.php
<?php Yii::app()->getModule('shop')->setTitle(Yii::t('main','Update'));?>
<?php echo $this->renderPartial('_form', array('model'=>$model)); ?>

src/backend/protected/modules/shop/views/products/view.php
<?php
Yii::app()->getModule('shop')->setTitle(Yii::t('main','View ').' #'.$model->product_id);
$this->widget('application.widgets.iDetailView', array(
	'data' => $model,
	'attributes' => array(
		'product_id',
		'sku',
		'category_id',
		'tax_id',
		'title',
		'description',
		'description_full',
		'price',
		'old_price',
		'language',
		'specifications',
		'featured',
		'published',
		'updated_datetime'
	),
));
?>